package custom.global.filter;

import java.io.IOException;

import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.annotation.WebFilter;

import org.osgi.framework.BundleContext;

@WebFilter("/*")
public class GlobalFilter implements Filter {

	private static final String ATTRIBUTE_BUNDLE_CONTEXT = "osgi-bundlecontext";

	private BundleContext bundleContext;

	@Override
	public void destroy() {
		// do nothing
	}

	@Override
	public void doFilter(ServletRequest request, ServletResponse response,
			FilterChain filterChain) throws IOException, ServletException {
		System.out.println("bundle context: " + this.bundleContext);
		request.setAttribute("my-bundle-context", this.bundleContext);

		// pass the request along the filter chain
		filterChain.doFilter(request, response);
	}

	@Override
	public void init(FilterConfig filterConfig) throws ServletException {
		this.bundleContext = (BundleContext) filterConfig.getServletContext()
				.getAttribute(ATTRIBUTE_BUNDLE_CONTEXT);
	}

}
